#include "testlib.h"

const int MAXNS[] = {
        1'000'000,      // 0
        10,             // 1
        100,            // 2
        5000,           // 3
        100'000,        // 4
        3'000'000,      // 5
};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    ensuref(!validator.group().empty(), "no group specified");
    
    int gr = validator.group()[0] - '0';
    
    int n = inf.readInt(1, MAXNS[gr], "n");
    inf.readEoln();
    std::vector<bool> was(n);
    for (int i = 0; i < n; i++) {
        if (i > 0) {
            inf.readSpace();
        }
        int a = inf.readInt(1, n, format("a[%d]", i + 1));
        ensuref(!was[a - 1], "duplicate element %d", a);
        was[a - 1] = true;
    }

    inf.readEoln();

    inf.readEof();

    return 0;
}
