#include <bits/stdc++.h>
#include "testlib.h"
using namespace std;

const int MAXP = 30000;

int n, m;
vector<string> a;

pair<int, int> next(int x, int y, char c)
{
    switch(c)
    {
        case 'U':
            return {(n + x - 1) % n, y};
        case 'D':
            return {(n + x + 1) % n, y};
        case 'R':
            return {x, (m + y + 1) % m};
        case 'L':
            return {x, (m + y - 1) % m};
    }
    assert(false);
    return {x, y};
}



inline void readAndCheckAnswer(InStream& in) {
    string s = in.readLine("[LRUD]{0, 30000}");
     
    if (int(s.length()) > MAXP)
        in.quitf(_wa, "Path length greater than %d", MAXP);

    vector<vector<int>> used(n, vector<int>(m, false));
    int x = 0, y = 0;
    used[x][y] = true;
    for (int i = 0; i < (int)s.length(); i++)
    {
        char cur = s[i];
        auto p = next(x, y, cur);
        x = p.first;
        y = p.second;
        if (!used[x][y] && a[x][y] == 'X')
        {
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m && i + j < x + y; j++)
                    if (a[i][j] == 'X' && !used[i][j])
                        in.quitf(_wa, "Trying to go to (%d, %d) before (%d, %d)", x + 1, y + 1, i + 1, j + 1);
        }
        used[x][y] = true;
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (a[i][j] == 'X' && !used[i][j])
                in.quitf(_wa, "Missed (%d, %d) cell in path", i + 1, j + 1);
}

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    
    n = inf.readInt();
    m = inf.readInt();
    inf.readEoln();
    a.resize(n);
    for (int i = 0; i < n; i++)
        a[i] = inf.readString();

    readAndCheckAnswer(ans);
    readAndCheckAnswer(ouf);

    quitf(_ok, "n=%d, m=%d", n, m);
}
