#include <bits/stdc++.h>
#include "testlib.h"
using namespace std;

int cur_test = -1;
const int GROUPS_CNT = 2;
const int MAXN = 100;

void write_test(vector<string> test) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << test.size() << ' ' << test[0].length() << endl;
    for (auto s : test)
        cout << s << endl;
}


void gen_rand(int n, int m, int k)
{
    vector<string> s(n, string(m, '.'));
    for (int i = 0; i < k; i++)
    {
        int x = rnd.next(n);
        int y = rnd.next(m);
        s[x][y] = 'X';
    }
    s[0][0] = 'S';
    write_test(s);
}

void gen_full(int n, int m)
{
    vector<string> s(n, string(m, 'X'));
    s[0][0] = 'S';
    write_test(s);
}

void gen_rand_group1(int n, int m, int k)
{
    k = min(k, m);
    vector<string> s(n, string(m, '.'));
    vector<bool> used(m);
    for (int i = 0; i < k; i++)
    {
        int x = rnd.next(n);
        int y = rnd.next(m);
        while (used[y])
            y = (y + 1) % m;
        used[y] = true;
        s[x][y] = 'X';
    }
    s[0][0] = 'S';
    write_test(s);
}

void gen_special_group1(int n, int m)
{
    vector<string> s(n, string(m, '.'));
    for (int i = 0; i < min(n, m); i++)
    {
        s[i][i] = 'X';
    }
    s[0][0] = 'S';
    write_test(s);
}

void gen_special2_group1(int n, int m)
{
    vector<string> s(n, string(m, '.'));
    int x = rnd.next(n);
    s[x] = string(m, 'X');
    s[0][0] = 'S';
    write_test(s);
}                                               

int med(int x)
{
    return rnd.next(max(x / 2, 1), x);
}

int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    //rand, full, rand_group1, special_group1, special2_group1
    for (int i = 1; i <= 100; i *= 10)
        for (int j = 1; j <= 100; j *= 10)
        {
            gen_rand_group1(med(i), med(j), 0);
            if (i != 1 || j != 1)
            {
                gen_rand_group1(med(i), med(j), j);
                int q = med(j);
                gen_rand_group1(med(i), q, rnd.next(1, q));
                gen_special_group1(med(i), med(j));
                gen_special2_group1(med(i), med(j));
            }
        }
    gen_rand_group1(MAXN, MAXN, 0);
    gen_rand_group1(MAXN - 1, MAXN, MAXN);
    gen_rand_group1(MAXN, MAXN - 3, rnd.next(1, MAXN - 3));
    gen_special_group1(MAXN - 1, MAXN - 1);
    gen_special2_group1(MAXN, MAXN);
    cerr << "GROUP ENDS" << endl;
    for (int i = 1; i <= 100; i *= 10)
        for (int j = 1; j <= 100; j *= 10)
        {
            if (i != 1 || j != 1)
            {
                gen_rand(med(i), med(j), med(i * j));
                gen_full(med(i), med(j));
            }
        }
    gen_rand(MAXN, MAXN, med(MAXN * MAXN));
    gen_full(MAXN, MAXN);
    return 0;
}